import { Editor } from 'slate';
import { CustomElement } from '../../custom-types';
import { ButtonOrientation } from './components';
import { EditorIconType } from './EditorIcon';
export declare type BlockFormat = CustomElement['type'] | Required<CustomElement>['align'];
export declare const isQuoteActive: (editor: Editor, stage: boolean) => boolean;
export declare const isBlockActive: (editor: Editor, format: BlockFormat, blockType?: 'type' | 'align') => boolean;
export declare const insertIframe: (editor: Editor, url: string, height: number) => void;
export declare const insertNFT: (editor: Editor, id: string) => void;
export declare const insertContentMedium: (editor: Editor, id: string) => void;
export declare const insertLink: (editor: Editor, url: string) => void;
export declare const wrapLink: (editor: Editor, url: string) => void;
export declare const unwrapLink: (editor: Editor) => void;
export declare const toggleBlockQuote: (editor: Editor) => void;
declare type BlockButtonProps = {
    title: string;
    format: BlockFormat;
    icon: EditorIconType;
    orientation?: ButtonOrientation;
    neverActive?: boolean;
    onClick?: () => void;
};
declare const BlockButton: ({ title, format, icon, orientation, neverActive, onClick }: BlockButtonProps) => JSX.Element;
export default BlockButton;
//# sourceMappingURL=BlockButton.d.ts.map