export declare enum EditorIconType {
    BOLD = "BOLD",
    ITALIC = "ITALIC",
    UNDERLINE = "UNDERLINE",
    CODE = "CODE",
    H1 = "H1",
    H2 = "H2",
    H3 = "H3",
    QUOTE = "QUOTE",
    QUOTE_STAGE = "QUOTE_STAGE",
    UL = "UL",
    OL = "OL",
    LINK = "LINK",
    REMOVE_LINK = "REMOVE_LINK",
    IMAGE = "IMAGE",
    UNDO = "UNDO",
    REDO = "REDO",
    VIDEO_EMBED = "VIDEO_EMBED",
    IFRAME_EMBED = "IFRAME_EMBED",
    NFT = "NFT",
    ALIGN_LEFT = "ALIGN_LEFT",
    ALIGN_CENTRE = "ALIGN_CENTRE",
    ALIGN_RIGHT = "ALIGN_RIGHT",
    ALIGN_BLOCK = "ALIGN_BLOCK"
}
declare type IconProps = {
    className?: string;
};
declare type Icon = (props: IconProps) => JSX.Element;
export declare const iconMap: Record<EditorIconType, Icon>;
declare const EditorIcon: ({ type, ...props }: IconProps & {
    type: EditorIconType;
}) => JSX.Element;
export default EditorIcon;
//# sourceMappingURL=EditorIcon.d.ts.map