"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var ContentMedium_1 = __importDefault(require("../components/ContentMedium"));
var HeadingElement_1 = __importStar(require("../components/HeadingElement"));
var IframeEmbed_1 = __importDefault(require("../components/IframeEmbed"));
var Link_1 = __importDefault(require("../components/Link"));
var Mention_1 = __importDefault(require("../components/Mention"));
var NFT_1 = __importDefault(require("../components/NFT"));
var Paragraph_1 = __importDefault(require("../components/Paragraph"));
var Element = function (initialProps) {
    var baseAttributes = initialProps.attributes, children = initialProps.children, element = initialProps.element;
    var style = { textAlign: element.align };
    var attributes = __assign(__assign({}, baseAttributes), { style: style });
    var props = __assign(__assign({}, initialProps), { attributes: attributes });
    switch (element.type) {
        case 'block-quote':
            return (react_1.default.createElement("blockquote", __assign({}, attributes, { className: element.stage ? 'lt-editor-block-quote-stage' : 'lt-editor-block-quote' }), children));
        case 'numbered-list':
            return (react_1.default.createElement("ol", __assign({}, attributes, { className: "lt-editor-numbered-list" }), children));
        case 'bulleted-list':
            return (react_1.default.createElement("ul", __assign({}, attributes, { className: "lt-editor-bulleted-list" }), children));
        case 'list-item':
            return (react_1.default.createElement("li", __assign({}, attributes, { className: "lt-editor-list-item" }), children));
        case 'heading-one':
            return react_1.default.createElement(HeadingElement_1.default, __assign({}, props, { type: HeadingElement_1.HeadingType.H1 }));
        case 'heading-two':
            return react_1.default.createElement(HeadingElement_1.default, __assign({}, props, { type: HeadingElement_1.HeadingType.H2 }));
        case 'heading-three':
            return react_1.default.createElement(HeadingElement_1.default, __assign({}, props, { type: HeadingElement_1.HeadingType.H3 }));
        case 'link':
            return react_1.default.createElement(Link_1.default, __assign({}, props, { element: element }));
        case 'content-medium':
            return react_1.default.createElement(ContentMedium_1.default, __assign({}, props, { element: element }));
        case 'iframe-embed':
            return react_1.default.createElement(IframeEmbed_1.default, __assign({}, props, { element: element }));
        case 'nft':
            return react_1.default.createElement(NFT_1.default, __assign({}, props, { element: element }));
        case 'mention':
            return react_1.default.createElement(Mention_1.default, __assign({}, props, { element: element }));
        default:
            return react_1.default.createElement(Paragraph_1.default, __assign({}, props));
    }
};
exports.default = Element;
//# sourceMappingURL=Element.js.map