"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toggleMark = void 0;
var react_1 = __importDefault(require("react"));
var slate_1 = require("slate");
var slate_react_1 = require("slate-react");
var components_1 = require("./components");
var EditorIcon_1 = __importDefault(require("./EditorIcon"));
var isMarkActive = function (editor, format) {
    var marks = slate_1.Editor.marks(editor);
    return marks ? marks[format] === true : false;
};
var toggleMark = function (editor, format) {
    var isActive = isMarkActive(editor, format);
    if (isActive) {
        slate_1.Editor.removeMark(editor, format);
    }
    else {
        slate_1.Editor.addMark(editor, format, true);
    }
};
exports.toggleMark = toggleMark;
var MarkButton = function (_a) {
    var format = _a.format, orientation = _a.orientation, icon = _a.icon, title = _a.title;
    var editor = slate_react_1.useSlate();
    return (react_1.default.createElement(components_1.EditorButton, { title: title, orientation: orientation, active: isMarkActive(editor, format), onClick: function (event) {
            event.preventDefault();
            exports.toggleMark(editor, format);
        } },
        react_1.default.createElement(EditorIcon_1.default, { type: icon })));
};
exports.default = MarkButton;
//# sourceMappingURL=MarkButton.js.map