import React from 'react';
import { RenderElementProps } from 'slate-react';
import { CustomElement, LinkElement, MentionElement } from '../../custom-types';
import { ContentMediumAttributes, ContentMediumResponse } from '../components/ContentMedium';
import { User, UserAttributes } from '../components/Mention';
import { NFTAttributes, NFTResponse } from '../components/NFT';
import { OembedProps } from '../components/OEmbed';
import { BlockFormat } from './BlockButton';
import { MarkFormat } from './MarkButton';
import { MentionSearchResult } from './mentions';
declare type HistoryButtonName = 'undo' | 'redo';
declare type PromptFunc<T = string> = () => Promise<T> | T;
export declare type RichTextEditorProps = {
    appBase?: string;
    readOnly?: boolean;
    value: CustomElement[];
    placeholder?: string;
    onChange: (value: CustomElement[]) => void;
    urlPrompt?: PromptFunc;
    contentMediaPrompt?: PromptFunc;
    iframePrompt?: PromptFunc<{
        url: string;
        height: number;
    }>;
    nftPrompt?: PromptFunc;
    requestContentMedium?: (id: string) => Promise<ContentMediumAttributes>;
    includedMedia?: ContentMediumResponse[];
    requestNFT?: (id: string) => Promise<NFTAttributes>;
    includedNFTs?: NFTResponse[];
    nftCardComponent?: React.ComponentType<{
        nftId: string;
    }>;
    hideButtons?: (MarkFormat | BlockFormat | HistoryButtonName)[];
    disableToolbar?: boolean;
    consent?: OembedProps['consent'];
    renderLink?: (props: RenderElementProps & {
        element: LinkElement;
        isInternal: boolean;
    }) => JSX.Element;
    reactToValueChanges?: boolean;
    disableMentions?: boolean;
    onSearchMentions?: (query: string) => Promise<MentionSearchResult>;
    renderMentionLink?: (props: RenderElementProps & {
        user?: User;
        element: MentionElement;
    }) => JSX.Element;
    mentionedUsers?: User[];
    requestMentionedUser?: (id: string) => Promise<UserAttributes>;
};
export declare type RichTextEditorRef = {
    reset: () => void;
};
export declare const RichTextEditor: React.ForwardRefExoticComponent<RichTextEditorProps & React.RefAttributes<RichTextEditorRef>>;
export {};
//# sourceMappingURL=RichTextEditor.d.ts.map