"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Portal = exports.ButtonOrientation = exports.ButtonGroup = exports.Toolbar = exports.Menu = exports.EditorButton = exports.isAlignFormat = exports.isListFormat = exports.TEXT_ALIGN_TYPES = exports.LIST_TYPES = void 0;
var react_1 = __importDefault(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
exports.LIST_TYPES = ['numbered-list', 'bulleted-list'];
exports.TEXT_ALIGN_TYPES = ['left', 'center', 'right', 'justify'];
var isListFormat = function (format) {
    return exports.LIST_TYPES.includes(format);
};
exports.isListFormat = isListFormat;
var isAlignFormat = function (format) {
    return exports.TEXT_ALIGN_TYPES.includes(format);
};
exports.isAlignFormat = isAlignFormat;
exports.EditorButton = react_1.default.forwardRef(function (_a, ref) {
    var title = _a.title, className = _a.className, active = _a.active, reversed = _a.reversed, disabled = _a.disabled, _b = _a.orientation, orientation = _b === void 0 ? ButtonOrientation.MIDDLE : _b, props = __rest(_a, ["title", "className", "active", "reversed", "disabled", "orientation"]);
    return (react_1.default.createElement("button", __assign({ type: "button", title: title }, props, { ref: ref, className: "lt-editor-toolbar-button " + (orientation === ButtonOrientation.LEFT
            ? 'lt-editor-toolbar-button-left'
            : orientation === ButtonOrientation.RIGHT
                ? 'lt-editor-toolbar-button-right'
                : orientation === ButtonOrientation.SINGLE
                    ? 'lt-editor-toolbar-button-single'
                    : '') + " " + (active ? 'lt-editor-toolbar-button-active' : 'lt-editor-toolbar-button-inactive') + " " + (disabled ? 'lt-editor-toolbar-button-disabled' : '') + " " + (className || '') })));
});
exports.Menu = react_1.default.forwardRef(function (_a, ref) {
    var className = _a.className, props = __rest(_a, ["className"]);
    return react_1.default.createElement("div", __assign({}, props, { ref: ref, className: className }));
});
exports.Toolbar = react_1.default.forwardRef(function (_a, ref) {
    var className = _a.className, props = __rest(_a, ["className"]);
    return react_1.default.createElement(exports.Menu, __assign({}, props, { ref: ref, className: 'lt-editor-toolbar' + (className || '') }));
});
var ButtonGroup = function (_a) {
    var children = _a.children;
    return react_1.default.createElement("span", { className: "lt-editor-toolbar-button-group" }, children);
};
exports.ButtonGroup = ButtonGroup;
var ButtonOrientation;
(function (ButtonOrientation) {
    ButtonOrientation["LEFT"] = "LEFT";
    ButtonOrientation["RIGHT"] = "RIGHT";
    ButtonOrientation["MIDDLE"] = "MIDDLE";
    ButtonOrientation["SINGLE"] = "SINGLE";
})(ButtonOrientation = exports.ButtonOrientation || (exports.ButtonOrientation = {}));
var Portal = function (_a) {
    var children = _a.children;
    return typeof document === 'object' ? react_dom_1.default.createPortal(children, document.body) : null;
};
exports.Portal = Portal;
//# sourceMappingURL=components.js.map