import { RenderElementProps } from 'slate-react';
import { ContentMediumElement } from '../../custom-types';
import { RichTextEditorProps } from '../RichTextEditor/RichTextEditor';
import { OembedProps } from './OEmbed';
declare type Props = RenderElementProps & {
    element: ContentMediumElement;
} & Pick<RichTextEditorProps, 'consent' | 'includedMedia' | 'requestContentMedium'>;
declare type CommonAttributes = {
    title: string;
    subtitle?: string;
};
declare type ImageAttributes = {
    media_type: 'image';
    original: string;
    thumbnail: string;
};
declare type VideoAttributes = {
    media_type: 'video';
    threeq_media_src: string;
    dimensions?: {
        height: number;
        width: number;
    };
};
declare type AudioAttributes = {
    media_type: 'audio';
    threeq_media_src: string;
};
declare type ExternalAttributes = {
    media_type: 'external_media';
    external_src: string;
    oembed_data?: OembedProps['data'];
};
export declare type ContentMediumAttributes = CommonAttributes & (ImageAttributes | VideoAttributes | AudioAttributes | ExternalAttributes);
export declare type ContentMediumResponse = {
    id: string;
    type: 'content_medium';
    attributes: ContentMediumAttributes;
};
declare const ContentMedium: (props: Props) => JSX.Element;
export default ContentMedium;
//# sourceMappingURL=ContentMedium.d.ts.map