"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Audio_1 = __importDefault(require("./Audio"));
var ExternalMedium_1 = __importDefault(require("./ExternalMedium"));
var Image_1 = __importDefault(require("./Image"));
var LoadingMessage_1 = __importDefault(require("./LoadingMessage"));
var ThreeQVideo_1 = __importDefault(require("./ThreeQVideo"));
var ContentMedium = function (props) {
    var requestContentMedium = props.requestContentMedium, includedMedia = props.includedMedia, element = props.element, consent = props.consent;
    var _a = __read(react_1.useState(), 2), loadedMedium = _a[0], setLoadedMedium = _a[1];
    var _b = __read(react_1.useState(), 2), error = _b[0], setError = _b[1];
    react_1.useEffect(function () {
        if (!requestContentMedium)
            return;
        requestContentMedium(element.id).then(setLoadedMedium).catch(setError);
    }, []);
    var noIncludedMedia = includedMedia === undefined || includedMedia === null;
    var included = (includedMedia || []).filter(Boolean).find(function (m) { return m.id === element.id; });
    var contentMedium = included
        ? __assign(__assign({}, included.attributes), { id: element.id }) : loadedMedium
        ? __assign(__assign({}, loadedMedium), { id: element.id }) : undefined;
    if (contentMedium) {
        switch (contentMedium.media_type) {
            case 'image':
                return react_1.default.createElement(Image_1.default, __assign({}, props, { url: contentMedium.original, title: contentMedium.title }));
            case 'video':
                return (react_1.default.createElement(ThreeQVideo_1.default, __assign({}, props, { id: element.id + "-" + element.nodeId, mediaSrc: contentMedium.threeq_media_src, dimensions: contentMedium.dimensions })));
            case 'audio':
                return react_1.default.createElement(Audio_1.default, __assign({}, props, { mediaSrc: contentMedium.threeq_media_src }));
            case 'external_media':
                return (react_1.default.createElement(ExternalMedium_1.default, __assign({}, props, { consent: consent, title: contentMedium.title, url: contentMedium.external_src, data: contentMedium.oembed_data })));
        }
    }
    if (!requestContentMedium && !error && !noIncludedMedia) {
        return react_1.default.createElement(LoadingMessage_1.default, __assign({}, props, { type: "error", message: "The linked content medium was not found." }));
    }
    if (error) {
        return (react_1.default.createElement(LoadingMessage_1.default, __assign({}, props, { type: "error", message: "An unknown error occurred. Please try deleting and reselecting the medium." })));
    }
    return react_1.default.createElement(LoadingMessage_1.default, __assign({}, props, { type: "info", message: "Please wait, the linked medium is loading..." }));
};
exports.default = ContentMedium;
//# sourceMappingURL=ContentMedium.js.map