"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Mention = function (props) {
    var _a, _b;
    var attributes = props.attributes, children = props.children, element = props.element, mentionedUsers = props.mentionedUsers, recentlyMentionedUsers = props.recentlyMentionedUsers, requestMentionedUser = props.requestMentionedUser, renderMentionLink = props.renderMentionLink;
    var _c = __read(react_1.useState(), 2), userAttributes = _c[0], setUserAttributes = _c[1];
    var _d = __read(react_1.useState(), 2), error = _d[0], setError = _d[1];
    react_1.useEffect(function () {
        if (!requestMentionedUser)
            return;
        requestMentionedUser(element.userId).then(setUserAttributes).catch(setError);
    }, [requestMentionedUser, element.userId]);
    var included = __spreadArray(__spreadArray([], __read((mentionedUsers || []))), __read(recentlyMentionedUsers)).filter(Boolean)
        .find(function (user) { return user.id.toString() === element.userId.toString(); });
    var user = included ? included : userAttributes ? { id: element.userId, attributes: userAttributes } : undefined;
    if (renderMentionLink) {
        return (react_1.default.createElement("span", __assign({}, attributes, { contentEditable: false }), renderMentionLink(__assign(__assign({}, props), { user: user, children: (react_1.default.createElement(react_1.default.Fragment, null,
                children,
                "@", (_a = user === null || user === void 0 ? void 0 : user.attributes) === null || _a === void 0 ? void 0 :
                _a.display_name)) }))));
    }
    var style = {
        padding: '3px 3px 2px',
        margin: '0 1px',
        verticalAlign: 'baseline',
        display: 'inline-block',
        borderRadius: '4px',
        backgroundColor: '#eee',
        fontSize: '0.9em',
    };
    // See if our empty text child has any styling marks applied and apply those
    var firstChild = element.children[0];
    if ('bold' in firstChild && firstChild.bold) {
        style.fontWeight = 'bold';
    }
    if ('italic' in firstChild && firstChild.italic) {
        style.fontStyle = 'italic';
    }
    return (react_1.default.createElement("span", __assign({}, attributes, { contentEditable: false, style: __assign(__assign({}, attributes.style), style) }),
        children,
        "@", (_b = user === null || user === void 0 ? void 0 : user.attributes) === null || _b === void 0 ? void 0 :
        _b.display_name));
};
exports.default = Mention;
//# sourceMappingURL=Mention.js.map