import PropTypes from 'prop-types';
import { RenderElementProps } from 'slate-react';
import { NFTElement } from '../../custom-types';
import { RichTextEditorProps } from '../RichTextEditor/RichTextEditor';
declare type Props = RenderElementProps & {
    element: NFTElement;
} & Pick<RichTextEditorProps, 'nftCardComponent' | 'requestNFT'>;
declare type Context = {
    t: (s: string) => string;
};
export declare type NFTResponse = {
    id: string;
    attributes: NFTAttributes;
};
export declare type NFTAttributes = {
    name: string;
    description: string;
    rarity: string;
    extended_info?: string;
    external_link?: string;
    cta_text?: string;
    amount: number;
    minted_at?: Date;
    collection_sponsor_name?: string;
    sponsor_name?: string;
    medium?: NFTMedium;
};
export declare type NFTMedium = {
    id: string;
    attributes: NFTMediumAttributes;
};
export declare type NFTMediumAttributes = {
    media_type: string;
    thumbnail?: string;
    image?: string;
    threeq_media_src?: string;
    original?: string;
};
declare const NFT: {
    (props: Props, context: Context): JSX.Element;
    contextTypes: {
        t: PropTypes.Requireable<(...args: any[]) => any>;
    };
};
export default NFT;
//# sourceMappingURL=NFT.d.ts.map