"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var LoadingMessage_1 = __importDefault(require("./LoadingMessage"));
var VoidElementWrapper_1 = __importDefault(require("./VoidElementWrapper"));
var useTimeout = function (initial, onTimeout, ms) {
    var _a = __read(react_1.useState(initial), 2), value = _a[0], setValue = _a[1];
    react_1.useEffect(function () {
        var timeout = setTimeout(function () {
            setValue(onTimeout);
        }, ms);
        return function () { return clearTimeout(timeout); };
    }, []);
    return value;
};
var NFT = function (props, context) {
    var _a, _b;
    var element = props.element, requestNFT = props.requestNFT, nftCardComponent = props.nftCardComponent;
    var _c = __read(react_1.useState(), 2), loadedNFT = _c[0], setLoadedNFT = _c[1];
    var _d = __read(react_1.useState(), 2), error = _d[0], setError = _d[1];
    var loadingFallback = useTimeout(true, function () { return false; }, 1000);
    react_1.useEffect(function () {
        if (!requestNFT)
            return;
        requestNFT(element.id).then(setLoadedNFT).catch(setError);
    }, []);
    var nft = loadedNFT ? __assign(__assign({}, loadedNFT), { id: element.id }) : undefined;
    if (!context.t)
        context.t = function (input) { return input; };
    if (nftCardComponent) {
        var Component = nftCardComponent;
        return (react_1.default.createElement(VoidElementWrapper_1.default, { elementProps: props },
            react_1.default.createElement(Component, { nftId: element.id })));
    }
    if (nft) {
        var renderRarityTag = function () {
            switch (nft.rarity) {
                case 'common':
                    return react_1.default.createElement(react_1.default.Fragment, null, context.t('Common'));
                case 'special':
                    return react_1.default.createElement(react_1.default.Fragment, null, context.t('Special'));
                case 'rare':
                    return react_1.default.createElement(react_1.default.Fragment, null, context.t('Rare'));
                case 'super_rare':
                    return react_1.default.createElement(react_1.default.Fragment, null, context.t('Super Rare'));
                case 'unique':
                    return react_1.default.createElement(react_1.default.Fragment, null, context.t('Unique'));
                default:
                    return react_1.default.createElement(react_1.default.Fragment, null, context.t('Undefined'));
            }
        };
        return (react_1.default.createElement(VoidElementWrapper_1.default, { elementProps: props },
            react_1.default.createElement("div", { className: "lt-editor-nft rarity--" + nft.rarity },
                react_1.default.createElement("div", { className: "lt-editor-nft-image-container" },
                    ((_a = nft.medium) === null || _a === void 0 ? void 0 : _a.attributes.image) && (react_1.default.createElement("div", null,
                        react_1.default.createElement("img", { className: "lt-editor-nft-image", src: (_b = nft.medium) === null || _b === void 0 ? void 0 : _b.attributes.image, alt: nft.name }))),
                    react_1.default.createElement("span", { className: "lt-editor-nft-rarity" }, renderRarityTag()),
                    react_1.default.createElement("span", { className: "lt-editor-nft-id" },
                        "#",
                        nft.id)),
                nft.amount > 0 && react_1.default.createElement("span", { className: "lt-editor-nft-amount" }, nft.amount),
                react_1.default.createElement("div", { className: "lt-editor-nft-body" },
                    react_1.default.createElement("div", { className: "lt-editor-nft-name" }, nft.name),
                    react_1.default.createElement("div", { className: "lt-editor-nft-description" }, nft.description)))));
    }
    if (!loadingFallback && !requestNFT && !error)
        return react_1.default.createElement(LoadingMessage_1.default, __assign({}, props, { type: "error", message: "The linked NFT was not found." }));
    if (error)
        return (react_1.default.createElement(LoadingMessage_1.default, __assign({}, props, { type: "error", message: "An unknown error occurred. Please try deleting and reselecting the NFT." })));
    return react_1.default.createElement(LoadingMessage_1.default, __assign({}, props, { type: "info", message: "Please wait, the linked NFT is loading..." }));
};
NFT.contextTypes = {
    t: prop_types_1.default.func,
};
exports.default = NFT;
//# sourceMappingURL=NFT.js.map