"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Link = function (_a) {
    var url = _a.url, data = _a.data, mediumTitle = _a.title;
    var title = (data === null || data === void 0 ? void 0 : data.title) || mediumTitle || 'Link to medium';
    return (react_1.default.createElement("a", { href: url, target: "_blank", rel: "noreferrer", className: "lt-editor-oembed-link" },
        (data === null || data === void 0 ? void 0 : data.thumbnail_url) && react_1.default.createElement("img", { src: data.thumbnail_url, alt: title, className: "lt-editor-oembed-link-thumbnail" }),
        react_1.default.createElement("p", null, title)));
};
var Photo = function (_a) {
    var data = _a.data;
    return (react_1.default.createElement("img", { src: data.url, alt: data.title, className: "lt-editor-oembed-photo" }));
};
var Video = function (_a) {
    var url = _a.url, data = _a.data, consent = _a.consent;
    react_1.useEffect(function () {
        if (consent === null || consent === void 0 ? void 0 : consent.show(url))
            return;
        var scripts = data.html.match(/<script.*>.*<\/script>/gm);
        if (!scripts)
            return;
        var range = document.createRange();
        var scriptsFragment = range.createContextualFragment(scripts.join('\n'));
        document.body.appendChild(scriptsFragment);
    }, [url, data, consent, data.html]);
    react_1.useEffect(function () {
        var _a, _b;
        if (typeof ((_b = (_a = window.instgrm) === null || _a === void 0 ? void 0 : _a.Embeds) === null || _b === void 0 ? void 0 : _b.process) === 'function')
            window.instgrm.Embeds.process();
    }, []);
    if (consent === null || consent === void 0 ? void 0 : consent.show(url)) {
        var Overlay = consent.overlay;
        return (react_1.default.createElement("div", { className: "lt-editor-oembed-video-consent-container" },
            react_1.default.createElement("div", { className: "lt-editor-oembed-video-consent", style: {
                    backgroundImage: "url('" + data.thumbnail_url + "')",
                    backgroundPosition: 'center',
                    backgroundSize: 'cover',
                } },
                react_1.default.createElement(Overlay, { url: url }))));
    }
    return (react_1.default.createElement("div", { className: "lt-editor-oembed-video", dangerouslySetInnerHTML: { __html: data.html }, style: { whiteSpace: 'normal' } }));
};
var OEmbed = function (_a) {
    var data = _a.data, props = __rest(_a, ["data"]);
    if ((data === null || data === void 0 ? void 0 : data.type) === 'photo')
        return react_1.default.createElement(Photo, __assign({}, props, { data: data }));
    if ((data === null || data === void 0 ? void 0 : data.type) === 'rich' || (data === null || data === void 0 ? void 0 : data.type) === 'video')
        return react_1.default.createElement(Video, __assign({}, props, { data: data }));
    return react_1.default.createElement(Link, __assign({}, props, { data: data }));
};
exports.default = OEmbed;
//# sourceMappingURL=OEmbed.js.map