"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var media_src_1 = require("../utils/media-src");
var ProcessingPlaceholder_1 = __importDefault(require("./ProcessingPlaceholder"));
var VoidElementWrapper_1 = __importDefault(require("./VoidElementWrapper"));
var playerUrl = 'https://player.3qsdn.com/js3q.latest.js';
var scriptIsPresent = function (url) { return !!document.querySelector("script[src=\"" + url + "\"]"); };
var ThreeQVideo = function (_a) {
    var mediaSrc = _a.mediaSrc, id = _a.id, dimensions = _a.dimensions, props = __rest(_a, ["mediaSrc", "id", "dimensions"]);
    var fullId = "threeq-" + id;
    var _b = media_src_1.parseMediaSrc(mediaSrc), playout = _b.playout, key = _b.key, timestamp = _b.timestamp;
    react_1.useEffect(function () {
        if (!scriptIsPresent(playerUrl)) {
            var script = document.createElement('script');
            script.type = 'text/javascript';
            script.src = playerUrl;
            script.crossOrigin = 'anonymous';
            script.async = true;
            document.body.appendChild(script);
        }
        var playerLoaded = function () {
            // @ts-ignore
            if (typeof js3q === 'undefined') {
                setTimeout(playerLoaded, 1000);
                return;
            }
            // @ts-ignore
            new js3q({
                dataid: playout,
                container: fullId,
                key: key,
                timestamp: timestamp,
                autoplay: false,
                width: '100%',
                height: '100%',
                layout: 'fixed',
            });
        };
        setTimeout(playerLoaded, 1000);
    }, [id, key, playout, timestamp]);
    return (react_1.default.createElement(VoidElementWrapper_1.default, { elementProps: props, className: "lt-editor-video", style: { whiteSpace: 'normal' } }, playout && key && timestamp ? (dimensions ? (react_1.default.createElement("div", { className: "lt-editor-video-container", style: { paddingBottom: "calc(" + dimensions.height + " / " + dimensions.width + " * 100%)" } },
        react_1.default.createElement("div", null,
            react_1.default.createElement("div", { id: fullId })))) : (react_1.default.createElement("div", { id: fullId }))) : (react_1.default.createElement(ProcessingPlaceholder_1.default, null))));
};
exports.default = ThreeQVideo;
//# sourceMappingURL=ThreeQVideo.js.map