"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var is_url_1 = __importDefault(require("is-url"));
var BlockButton_1 = require("../RichTextEditor/BlockButton");
var withLinks = function (editor) {
    var insertData = editor.insertData, insertText = editor.insertText, isInline = editor.isInline;
    editor.isInline = function (element) {
        return element.type === 'link' ? true : isInline(element);
    };
    editor.insertText = function (text) {
        if (text && is_url_1.default(text)) {
            BlockButton_1.wrapLink(editor, text);
        }
        else {
            insertText(text);
        }
    };
    editor.insertData = function (data) {
        var text = data.getData('text/plain');
        if (text && is_url_1.default(text)) {
            BlockButton_1.wrapLink(editor, text);
        }
        else {
            insertData(data);
        }
    };
    return editor;
};
exports.default = withLinks;
//# sourceMappingURL=with-links.js.map