"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var slate_1 = require("slate");
var components_1 = require("../RichTextEditor/components");
var unwrapListIfItemEmpty = function (editor) {
    var _a;
    var _b = __read(slate_1.Editor.nodes(editor, {
        match: function (n) { return !slate_1.Editor.isEditor(n) && slate_1.Element.isElement(n) && n.type === 'list-item'; },
    }), 1), listItem = _b[0];
    if (listItem &&
        listItem[0] &&
        ((_a = listItem[0].children) === null || _a === void 0 ? void 0 : _a.length) === 1 &&
        'text' in listItem[0].children[0] &&
        listItem[0].children[0].text === '') {
        slate_1.Transforms.unwrapNodes(editor, {
            match: function (n) { return components_1.LIST_TYPES.includes((!slate_1.Editor.isEditor(n) && slate_1.Element.isElement(n) && n.type)); },
            split: true,
        });
        var newProperties = { type: 'paragraph' };
        slate_1.Transforms.setNodes(editor, newProperties);
        return true;
    }
};
var withListDestruction = function (editor) {
    var insertBreak = editor.insertBreak, deleteBackward = editor.deleteBackward, deleteForward = editor.deleteForward;
    editor.insertBreak = function () {
        if (unwrapListIfItemEmpty(editor))
            return;
        insertBreak();
    };
    editor.deleteBackward = function (unit) {
        if (unit === 'character' && unwrapListIfItemEmpty(editor))
            return;
        deleteBackward(unit);
    };
    editor.deleteForward = function (unit) {
        if (unit === 'character' && unwrapListIfItemEmpty(editor))
            return;
        deleteForward(unit);
    };
    return editor;
};
exports.default = withListDestruction;
//# sourceMappingURL=with-list-destruction.js.map