"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseEditorInput = void 0;
var parseEditorInput = function (input) {
    return JSON.parse(input, function (key, value) {
        if (key === '' && typeof value !== 'object') {
            throw new Error('Invalid JSON');
        }
        else if (key === '') {
            // check if valid slate json
            // is Array
            if (!Array.isArray(value))
                throw new Error('JSON is not an array');
            // has objects inside
            if (value.some(function (item) { return typeof item !== 'object'; }))
                throw new Error('JSON is not an array of objects');
            // has `text` property or `type` and `children` property
            if (value.some(function (item) { return !item.hasOwnProperty('text') && (!item.hasOwnProperty('type') || !item.hasOwnProperty('children')); })) {
                throw new Error('JSON is not an array of objects with type and children property');
            }
        }
        return value;
    });
};
exports.parseEditorInput = parseEditorInput;
//# sourceMappingURL=parse-input.js.map